//
//  MRRangeSet.h
//  MRFoundation
//
//  Copyright (c) 2008-2018 MacRabbit. All rights reserved.
//

#import <Foundation/Foundation.h>


#ifdef EXPORTED_CLASS
EXPORTED_CLASS
#endif

NS_ASSUME_NONNULL_BEGIN


@interface MRRangeSet : NSObject

+ (MRRangeSet *)rangeSet;
- (instancetype)init; // Designated initializer
- (instancetype)initWithRangeValues:(NSArray<NSValue *> *)ranges;

@property BOOL allowsZeroLengthRanges; // Defaults to NO

- (void)minusRange:(NSRange)range NS_REFINED_FOR_SWIFT;
- (void)unionRange:(NSRange)range NS_REFINED_FOR_SWIFT;
- (void)removeAllRanges;

- (void)shiftRangesStartingAtIndex:(NSUInteger)index by:(NSInteger)delta;

- (void)minusRanges:(NSArray<NSValue *> *)ranges NS_REFINED_FOR_SWIFT;
- (void)unionRanges:(NSArray<NSValue *> *)ranges NS_REFINED_FOR_SWIFT;

@property(readonly) BOOL isEmpty;
- (BOOL)intersectsRange:(NSRange)range NS_SWIFT_NAME(intersects(_:));
- (void)enumerateIntersectionRangesForRange:(NSRange)range usingBlock:(NS_NOESCAPE void(^)(NSRange))enumerator;

@property(readonly) NSArray<NSValue *> *rangeValues;
- (NSRange *__nonnull)getRangeBufferAndCount:(NSUInteger *)count NS_RETURNS_INNER_POINTER; // Never free or change the buffer, it is owned by the set
- (NSArray *)ranges DEPRECATED_ATTRIBUTE NS_SWIFT_UNAVAILABLE("");

@end

NS_ASSUME_NONNULL_END
